// ConstructorDestructor
// Shows the order of constructor and destructor calls

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;

//A simple class with a constructor and destructor
class bar 
{
public:
   bar();
   ~bar();
};

//Let the world know when bar is created
bar::bar() 
{
	Console::WriteLine(S"bar created");
}

//Let the world know when bar is destroyed
bar::~bar() 
{
	Console::WriteLine(S"bar destroyed");
}

//Foo is a class that contains another class,
//in this case bar. Because it contains another
//class, creating and destroying foo shows
//the order of constructor and destructor calls
class foo 
{
public:
   bar oTemp;
   foo();
   ~foo();
};

//Let the world know that a foo is born
foo::foo() 
{
	Console::WriteLine(S"foo created");
}

//Let the world know foo has been destroyed
foo::~foo() 
{
	Console::WriteLine("A foo and his memory are soon parted");
}


//This is the main function It simply creates an object
//of type foo. When oTemp is created, the constructors
//are automatically called. When the program finishes,
//Temp is automatically destroyed so you can see
//the order of destructor calls.
#ifdef _UNICODE
int wmain(void)
#else
int main(void)
#endif
{
	foo oTemp;
	return 0;
}