// DataStructures
// Demonstrates a variety of data structures

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;
using namespace System::Collections;

//A class for user later on
__gc class PointList
{
public:
	int nX;
	int nY;
	PointList *poNext;
};

//Hang out until the user is finished
void HangOut()
{
	Console::WriteLine(L"Hit the enter key to stop the program");
	Console::ReadLine();
}

// This is the entry point for this application
#ifdef _UNICODE
int wmain(void)
#else
int main(void)
#endif
{
	//Enums
	//Types of shapes
	enum Shapes 
	{
		Circle,
		Square
	};

	//Use the enum as a data type
	Shapes oMyShape;

	//Set the object to an enum value
	//Note that oMyShape = Oval would cause a syntax error
	oMyShape = Circle;

	//Arrays
	//Declare an array of ints
	Console::WriteLine(S"C++ Array");
	int anNumbers[5] = {1, 2, 3, 5, 3};

	//Print them out
	for (int i = 0; i < 5; i++)
	{
		Console::WriteLine(anNumbers[i]);
	}

	//Create a string array
	String *aszFoo[] = {S"hello", S"goodbye"};
	Console::WriteLine(S"The String array has {0} in it", aszFoo[1]);


	//Built in data structures
	//We'll start by instantiating a class for use later on
	PointList *poFirst = new PointList();

	//ArrayList: an open ended array with an enumerator
	//Note that any type of garbage collected object can be inserted
	Console::WriteLine(S"ArrayList");
	ArrayList *poArray = new ArrayList();
	//Add a string
	poArray->Add(S"A string");
	//Add a pointlist object
	poArray->Add(poFirst);

	//What is the first item?
	Console::WriteLine(S"The first item in the ArrayList is {0}", poArray->get_Item(0)->ToString());
	//Now lets iterate through them
    IEnumerator *poEnumerator = poArray->GetEnumerator();
    while ( poEnumerator->MoveNext() )
		Console::WriteLine( poEnumerator->Current );

	//Find the index of the string "A string"
	Console::WriteLine(S"The index is {0}", poArray->IndexOf(S"A string").ToString());

	//We'll do something similar with a stack
	Console::WriteLine(S"Stack");
	Stack *poStack = new Stack();
	//Put on a string
	poStack->Push(S"A string");
	//Put on an object
	poStack->Push(poFirst);
	//Put on another string
	poStack->Push(S"Another string");
	//Remove the last string
	poStack->Pop();

	//Now lets iterate through them
    poEnumerator = poStack->GetEnumerator();
    while ( poEnumerator->MoveNext() )
		Console::WriteLine( poEnumerator->Current );

	HangOut();
    return 0;
}