// Draw2
// Uses a linked list to store a series of points
// Displays the list on the screen
// Unmanaged

#include "stdafx.h"
#include <iostream.h>

//Stores point information
//Uses a linked list
class PointList 
{
public:
   int nX;
   int nY;
   PointList  *poNext;
};

//Gets the values for a new point
void NewPoint(PointList *poNew)
{
	//Read the x and y positions and store them in the structure
	cout << "What is the x position?";
	cin >> poNew->nX;
	cout << "What is the y position?";
	cin >> poNew->nY;
	//Set the pointer to null
	poNew->poNext = 0;
}

//Draws the points
void DrawPoint(PointList *poPoint)
{
	//Is there a place to draw to?
	if (poPoint->poNext)
	{
		//Print out the coordinates
		cout << "From " << poPoint->nX << "," << poPoint->nY << " to " << poPoint->poNext->nX << "," << poPoint->poNext->nY << endl;
	}

}


int _tmain(int argc, _TCHAR* argv[])
{
	//Points to the list of coordinates
	PointList *poPoints = 0;
	//Points to the last PointList created
	PointList *poLast;
	//Points to a new PointList
	PointList *poNew;
	//For storing the user response
	char cMore;

	//A flag to tell us to stop
	bool fFinished = false;

	while (!fFinished)
	{
		//Create a new point structure
		poNew = new PointList;
		if (!poPoints)
		{
			//If it is the first one, initialize poPoints
			poPoints = poNew;
		}
		else
		{
			//Connect it to the last one
			poLast->poNext = poNew;
		}
		//Now update poLast
		poLast = poNew;

		//Read in the values
		NewPoint(poNew);

		//Should we read more in?
		cout << "Hit y to enter a new point";
		cin >> cMore;
		if (cMore != 'y')
		{
			fFinished = true;
		}

	}

	//Now draw the points
	poLast = poPoints;
	while (poLast)
	{
		//Draw it
		DrawPoint(poLast);
		//Advance
		poLast = poLast->poNext;
	}



	//Now clean up the memory
	poLast = poPoints;
	while (poLast)
	{
		PointList *poNext;
		poNext = poLast->poNext;

		//Free up the memory
		delete poLast;

		//Now advance
		poLast = poNext;
	}
	


	return 0;
}

