// Draw4
// Introduces class structures


#include "stdafx.h"

#using <mscorlib.dll>
#using <System.dll>
#using <System.Windows.Forms.dll> 
#using <System.Drawing.dll> 

using namespace System;
using namespace System::Drawing; 
using namespace System::Windows::Forms; 
using namespace System::Collections;

//Stores line information
__gc class LineObject 
{
public:
	void Initialize();
	void Draw(Graphics *poG);
private:
   int m_nXFrom;
   int m_nYFrom;
   int m_nXTo;
   int m_nYTo;
};

//Initialize values for this line object
void LineObject::Initialize()
{
	//Read the x and y positions and store them in the structure
	Console::WriteLine(S"What is the starting x position?");
	m_nXFrom = Int32::Parse(Console::ReadLine());
	Console::WriteLine(S"What is the starting y position?");
	m_nYFrom = Int32::Parse(Console::ReadLine());
	Console::WriteLine(S"What is the ending x position?");
	m_nXTo = Int32::Parse(Console::ReadLine());
	Console::WriteLine(S"What is the ending y position?");
	m_nYTo = Int32::Parse(Console::ReadLine());
}

//Draws the line
void LineObject::Draw(Graphics *poG)
{
	//Create a pen with which to draw
	Pen *poPen = new Pen(Color::Red);
	//Draw the line
	poG->DrawLine(poPen, m_nXFrom, m_nYFrom, m_nXTo, m_nYTo); 
}


//Stores all of the lines to draw
__gc class DisplayObject
{
public:
	void Add();
	void Draw(Graphics *poG);
	void Initialize();
private:
	ArrayList *m_paLines;
};

//Initialize the DisplayObject structures
void DisplayObject::Initialize()
{
	m_paLines = new ArrayList();
}

//Add a new object
void DisplayObject::Add()
{
	bool fFinished = false;
	String *pszMore;

	while (!fFinished)
	{
		//Create a new line object
		LineObject *poLine = new LineObject();
		//Initialize it
		poLine->Initialize();
		//Store it in the structure
		m_paLines->Add(poLine);

		//Should we add another one?
		Console::WriteLine("Hit y to enter a new line");
		pszMore = Console::ReadLine();
		if (!pszMore->Equals(S"y"))
		{
			fFinished = true;
		}
	}
}

//Draw all of the lines
void DisplayObject::Draw(Graphics *poG)
{
	//Go through each of the line objects
    IEnumerator *poEnumerator = m_paLines->GetEnumerator();
    while (poEnumerator->MoveNext())
	{
		//Call the draw method for the object
		static_cast<LineObject*>(poEnumerator->Current)->Draw(poG);
	}
}


// This is the entry point for this application
#ifdef _UNICODE
int wmain(void)
#else
int main(void)
#endif
{
	//Structures for drawing graphics
	Form *poForm = new Form(); 
	Graphics *poGraphics = poForm->CreateGraphics(); 
	DisplayObject *poDisplay = new DisplayObject();

	//Initialize the display object
	poDisplay->Initialize();

	//Add the lines
	poDisplay->Add();

	//Show the display surface
	poForm->Show();

	//Draw the lines
	poDisplay->Draw(poGraphics);

	//Free up the graphics surface
	poGraphics->Dispose();

	//Hang out until the user closes the form
	Application::Run(poForm);

}