// Events
// Processes events on a WinForm applicatin

#include "stdafx.h"

#using <mscorlib.dll>
#using <System.Windows.Forms.dll> 
#using <System.Drawing.dll>
#using <System.dll>

using namespace System;
using namespace System::Windows::Forms; 
using namespace System::Collections;
using namespace System::Drawing;

__gc class MyForm : public Form
{
public:
	MyForm();
protected:
	PictureBox *m_poImg;
	Label *m_poXPosition;
	void Change_Clicked(Object *sender, EventArgs *e);
	void OnMouseMove(MouseEventArgs *e);
};

//When the form is created, we'll populate it
MyForm::MyForm() : Form()
{
	//Create a new button
	Button *poChange = new Button();
	//Create a text editor
	RichTextBox *poTE = new RichTextBox();
	//Create an image
	m_poImg = new PictureBox();

	//Set the size of the form
	this->Width = 600;
	this->Height = 400;

	//Set the button properties
	poChange->Text = S"Change";
	poChange->Left = 280;
	poChange->Top = 350;
	poChange->BackColor = Color::Blue;


	//Make this the accept button for the form
	this->AcceptButton = poChange;
	//Set the button click handler
	poChange->Click += new EventHandler(this, Change_Clicked);

	//Add the button to the form
	this->Controls->Add(poChange);


	//Set the text editor properties
	poTE->Left = 200;
	poTE->Top = 10;
	poTE->Width = 380;
	poTE->Height = 300;
	poTE->Text = S"Edit me";

	//Add the text editor to the page
	this->Controls->Add(poTE);

	//Set the image properties
	m_poImg->Left = 10;
	m_poImg->Top = 10;
	m_poImg->Width = 160;
	m_poImg->Height = 120;
	m_poImg->Image = Image::FromFile("..\\desert4.jpg");
	m_poImg->SizeMode = PictureBoxSizeMode::StretchImage;

	//Add it to the page
	this->Controls->Add(m_poImg);

	//Add the label
	m_poXPosition = new Label();
	m_poXPosition->Left = 10;
	m_poXPosition->Top = 150;
	m_poXPosition->Text = "X";

	//Add it to the page
	this->Controls->Add(m_poXPosition);

}

//Handle clicks on the Change button
void MyForm::Change_Clicked(Object *sender, EventArgs *e) 
{
	//Switch the image that is displayed
	m_poImg->Image = Image::FromFile("..\\desert5.jpg");
}

//Handle mouse moves on the form
void MyForm::OnMouseMove(MouseEventArgs *e) 
{
	//Display the x position
	m_poXPosition->Text = e->X.ToString();
}

// This is the entry point for this application
#ifdef _UNICODE
int wmain(void)
#else
int main(void)
#endif
{
	Application::Run(new MyForm());
	return 0;
}