// Graphics
// Demonstrates .NET graphics

#include "stdafx.h"

#using <mscorlib.dll>
#using <System.Windows.Forms.dll> 
#using <System.dll>
#using <System.Drawing.dll> 

using namespace System;
using namespace System::Drawing; 
using namespace System::Windows::Forms; 


// This is the entry point for this application
#ifdef _UNICODE
int wmain(void)
#else
int main(void)
#endif
{
	//Structures for drawing graphics
	Form *poForm = new Form(); 
	Graphics *poGraphics = poForm->CreateGraphics(); 

	//Create a red pen with which to draw
	Pen *poPen = new Pen(Color::Red);

	//Show the display surface
	poForm->Show();

	//Draw a line
	poGraphics->DrawLine(poPen, 10, 10, 120, 150); 

	//Now use a different color and width
	poPen->Color = Color::FromArgb(100, 255, 200);
	poPen->Width = 5;
	poGraphics->DrawLine(poPen, 120, 150, 10, 150); 

	//Use the same pen to draw an ellipse
	poGraphics->DrawEllipse(poPen, 10, 150, 40, 60);

	//Create a new brush
	SolidBrush *poBrush = new SolidBrush(Color::Tomato);
	//Draw a filled rectangle with it
	poGraphics->FillRectangle(poBrush, 50, 150, 40, 60);

	//Create a font
	Font *poFont = new Font("Helvetica", 22);
	//Draw some text with it
	poGraphics->DrawString(S"Hello", poFont, poBrush, 200, 200);

	//Free up the graphics surface
	poGraphics->Dispose();

	//Hang out until the user closes the form
	Application::Run(poForm);
}