// Inherit
// Illustrates overriding a function through inheritance

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;

//This is the base class. It contains a price and a
//way to print the price.
class Base 
{
public:
	int nPrice;
	void PrintMe();
};

//Print it, letting us know it is the base function
void Base::PrintMe() 
{
	Console::WriteLine(S"Base {0}", nPrice.ToString());
}

//Derived is inherited from Base. But it has a
//different PrintMe() function.
class Derived : public Base 
{
public:
	void PrintMe();
};

//Let us know the derived one was called. Then
//call the base one.
void Derived::PrintMe() {
	Console::WriteLine(S"Derived");
	//Now call the parent
	Base::PrintMe();
}


//Hang out until the user is finished
void HangOut()
{
	Console::WriteLine(L"Hit the enter key to stop the program");
	Console::ReadLine();
}

// This is the entry point for this application
#ifdef _UNICODE
int wmain(void)
#else
int main(void)
#endif
{
   Base  oBaseClass;
   Derived  oDerivedClass;

   oBaseClass.nPrice = 1;
   oDerivedClass.nPrice = 7;

   Console::WriteLine(S"Call base class function");
   oBaseClass.PrintMe();

   Console::WriteLine(S"Call derived class function");
   oDerivedClass.PrintMe();
   HangOut();
   return 0;
}