// Inherit2
// Illustrates virtual functions

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;

//This is the base class. 
class Base 
{
public:
	void PrintMe();
	virtual void PrintMeV();
};

//Print it, letting us know it is the base function
void Base::PrintMe() 
{
	Console::WriteLine(S"Non-virtual base");
}

void Base::PrintMeV() 
{
	Console::WriteLine(S"Virtual base");
}

//Derived is inherited from Base.
class Derived : public Base 
{
public:
	void PrintMe();
	virtual void PrintMeV();
};

//Let us know the derived one was called.
void Derived::PrintMe() 
{
	Console::WriteLine(S"Non-virtual derived");
}

void Derived::PrintMeV() 
{
	Console::WriteLine(S"Virtual derived");
}


//Hang out until the user is finished
void HangOut()
{
	Console::WriteLine(L"Hit the enter key to stop the program");
	Console::ReadLine();
}

// This is the entry point for this application
#ifdef _UNICODE
int wmain(void)
#else
int main(void)
#endif
{
	//Create a base class dynamically
	Base  *poBase = new Base();

	//Call the two functions
	Console::WriteLine(S"Using the base class");
	poBase->PrintMe();
	poBase->PrintMeV();

	delete poBase;

	//Now use the base class pointer to point to the derived class
	poBase = new Derived();

	//Call the two functions
	Console::WriteLine(S"Using the derived class");
	poBase->PrintMe();
	poBase->PrintMeV();

	HangOut();
	return 0;
}