// SquareRoot
// Exception handling

#include "stdafx.h"

#using <mscorlib.dll>

using namespace System;

__gc class SquareRootException : public Exception
{
public:
	SquareRootException(String *s) : Exception(s) {};
};

//Returns the square root
//Throws an exception if there is a range problem
double SquareRoot(int nNumber) 
{
	if (nNumber < 0)
	{
		throw new SquareRootException(S"Number must be positive");
	}
	return Math::Sqrt(nNumber);
}


//This routine prompts the user for a number.
//It returns the value of the number
int GetNumber() 
{
	int nNumber;

	Console::WriteLine(S"What is the number?");
	try
	{
		nNumber = Int32::Parse(Console::ReadLine());
	}
	catch (FormatException *e)
	{
		Console::WriteLine(e->Message);
		Console::WriteLine("Next time, please enter an integer. I'm going to guess you meant 1.");
		nNumber = 1;
	}
	return nNumber;
}

// This is the entry point for this application
#ifdef _UNICODE
int wmain(void)
#else
int main(void)
#endif
{
	int nNumber;

	//Get numbers from the user, until the user
	//types 0
	while (nNumber = GetNumber()) 
	{
		//Now we will output the result
		try
		{
			Console::WriteLine(S"The square root of {0} is {1}", nNumber.ToString(), SquareRoot(nNumber).ToString());
		}
		catch (Exception *e)
		{
			Console::WriteLine(e->Message);
		}
	}

	//Now we are finished
	Console::WriteLine(S"Bye");
    return 0;
}